###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.6 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.SimpleItem
import Products
import base_item

manage_add_note_form = HTMLFile('note_add', globals())

def manage_add_note(self, id='', body='', REQUEST=None, RESPONSE=None):
    "Add an instance of the Note class"

    if not id:

	id = str(self.get_unique_id())

    self._setObject(id, note(id, body))

    if RESPONSE is not None:

	RESPONSE.redirect(self.absolute_url())


class note(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.SimpleItem.Item,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'Note'
	icon = 'misc_/Transform/dtmldoc.gif'
	default_catalog = 'Catalog'

	_properties = (
		{'id':'body', 'type':'text'},
		)

	manage_options = (
		{'label':'Edit', 'action':'manage_main'},
		{'label':'View', 'action':''},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Notes',
		 ('',)),
		)

	index_html = HTMLFile('note_index', globals())
	#manage_main = HTMLFile('note_edit', globals())


	def __init__(self, id, body=''):
		"Initialize the class instance"

		self.id = id
		self.body = body
		self.index_object()


	def manage_edit(self, body, REQUEST=None):
		"Change properties for the class instance."

		self.body = body
		self.reindex_object()

		if REQUEST is not None:
			return MessageDialog(
			   title='Edited',
			   message="Properties for %s has been changed." % self.id,
			   action = "./manage_main"
			   )


default__class_init__(note)

